var alertDialog;
var lap = 1800000;

// container for all the folder properties
var DisplayQuotaFolderPropsSink = {
    setFolderType: function(folderTypeString) {},
    setFolderTypeDescription: function(folderDescription) {},
    setFolderPermissions: function(folderPermissions) {},
    serverDoesntSupportACL : function() {},
    setQuotaStatus : function() {},

    showQuotaData : function(showData) {
	var quotaStatusBar = document.getElementById('DisplayQuota-statusbar');
	var quotaProgress = document.getElementById('DisplayQuota-progress-icon');
	var quotaLabelPC = document.getElementById('DisplayQuota-percent');

	var DisplayQuotaPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	var DisplayQuotaStrBundleService = Components.classes["@mozilla.org/intl/stringbundle;1"].getService();
	var DisplayQuotaStrBundle = DisplayQuotaStrBundleService.createBundle("chrome://displayquota/locale/displayquota.properties");
	
      	if(showData == false) {
		var noquota = DisplayQuotaStrBundle.GetStringFromName("noquota");
      		quotaProgress.setAttribute("tooltiptext",noquota);
		quotaLabelPC.setAttribute("value","");
		quotaProgress.setAttribute("value",0);	
      	} 
    },

    setQuotaData : function(root, usedKB, maxKB)
    {
      	var quotaStatusBar = document.getElementById('DisplayQuota-statusbar');
      	var quotaProgress = document.getElementById('DisplayQuota-progress-icon');
        var quotaLabelText = document.getElementById('DisplayQuota-text');
	var quotaLabelPC = document.getElementById('DisplayQuota-percent');
	var quotaIcon = document.getElementById('DisplayQuota-icon');
      	
	var DisplayQuotaPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);

	var DisplayQuotaStrBundleService = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService);

	try {
		var DisplayQuotaStrBundle = DisplayQuotaStrBundleService.createBundle("chrome://displayquota/locale/displayquota.properties");
	} catch (ex) { dump("erreur bundle: " + ex + "\n"); }

	var donotwarn = true;
	var donotbug = false;
	var warnpercent = 90;
	var lastwarn = "0";
	var lastpercentage = 0;

	// get the values from the perferences
	if (DisplayQuotaPrefs.getPrefType("extension.displayquota.donotwarn") == DisplayQuotaPrefs.PREF_BOOL) {
		donotwarn = DisplayQuotaPrefs.getBoolPref("extension.displayquota.donotwarn");
	}

	if (DisplayQuotaPrefs.getPrefType("extension.displayquota.warnpercent") == DisplayQuotaPrefs.PREF_INT){
		warnpercent = DisplayQuotaPrefs.getIntPref("extension.displayquota.warnpercent");	
	}

	if (DisplayQuotaPrefs.getPrefType("extension.displayquota.donotbug") == DisplayQuotaPrefs.PREF_BOOL) {
		donotbug = DisplayQuotaPrefs.getBoolPref("extension.displayquota.donotbug");
	}

	if (DisplayQuotaPrefs.getPrefType("extension.displayquota.lastwarn") == DisplayQuotaPrefs.PREF_STRING){
		var tmpDate = new Date(DisplayQuotaPrefs.getCharPref("extension.displayquota.lastwarn"));
		lastwarn = tmpDate.getTime();
	}

	if (DisplayQuotaPrefs.getPrefType("extension.displayquota.lastpercentage") == DisplayQuotaPrefs.PREF_INT){
		lastpercentage = DisplayQuotaPrefs.getIntPref("extension.displayquota.lastpercentage");	
	}


	var percentage = (maxKB != 0) ? Math.round(usedKB / maxKB * 100) : 0;

	var unitMax = DisplayQuotaStrBundle.GetStringFromName("kilobyte");
	var unitUsed = DisplayQuotaStrBundle.GetStringFromName("kilobyte");

      	var niceUsed = usedKB;
      	var niceMax = maxKB / 1024;
 
      	if(usedKB >= 1024) {
		unitUsed = DisplayQuotaStrBundle.GetStringFromName("megabyte");
	 	niceUsed =  usedKB / 1024;	
      	}
      	if(niceUsed >= 1024) {
		unitUsed = DisplayQuotaStrBundle.GetStringFromName("gigabyte");
		niceUsed =  niceUsed / 1024;	
      	}
      
	if(niceMax >= 1024) {
		niceMax = niceMax / 1024;
		unitMax = DisplayQuotaStrBundle.GetStringFromName("gigabyte");
      	} else {
      		unitMax = DisplayQuotaStrBundle.GetStringFromName("megabyte");
      	}
      	
	quotaProgress.setAttribute("value",percentage);
      	quotaLabelPC.setAttribute("value",percentage+"%");
	
	var usage = DisplayQuotaStrBundle.GetStringFromName("usage");
	var of = DisplayQuotaStrBundle.GetStringFromName("of");

  	quotaProgress.setAttribute("tooltiptext",usage  + ": " + niceUsed.toFixed(2) + " " + unitUsed  + " " + of + " " +  niceMax.toFixed(2) + " " + unitMax + " (" + percentage +"%)");
      	if (percentage < 50) quotaLabelPC.setAttribute("status","normal");
      	if (percentage >= 50) quotaLabelPC.setAttribute("status","middle");
      	if (percentage >= 70) quotaLabelPC.setAttribute("status","warning");
	if (percentage >= 90) quotaLabelPC.setAttribute("status","alert");
      	if (percentage >= 100) {
		var overalert = DisplayQuotaStrBundle.GetStringFromName("overalert");
		quotaLabelPC.setAttribute("status","over");
		quotaIcon.setAttribute("hidden","false");
		quotaIcon.setAttribute("src","chrome://displayquota/skin/error.png");
		if(! donotwarn) alert(overalert);
      	}

	if (percentage >= warnpercent) {
		var warn1 = DisplayQuotaStrBundle.GetStringFromName("warnalert1");
		var warn2 = DisplayQuotaStrBundle.GetStringFromName("warnalert2");
		
		quotaIcon.setAttribute("hidden","false");

		if (alertDialog) {
			alertDialog.close();
			alertDialog = null;
		}

		var currentDate = new Date();
		var currentTime = currentDate.getTime();
		var elapsed = currentTime - lastwarn;

		if(! donotbug || elapsed >= lap || (lastpercentage < 100 && percentage >= 100) ) {
			//if (! donotwarn && ! alertDialog) alertDialog = window.openDialog('chrome://displayquota/content/displayquotaalert.xul',"alert","chrome",warn1 + " " + percentage + "% "+ warn2);
			if (! donotwarn && ! alertDialog) alertDialog = window.openDialog('chrome://displayquota/content/displayquotaalert.xul',"alert","chrome",percentage);
		}
 	}

	if (percentage < warnpercent) quotaIcon.setAttribute("hidden","true");

    }
};

function checkQuota(item,event) {


	var DisplayQuotaPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);


	var DisplayQuotaStrBundleService = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService);

	try {
		var DisplayQuotaStrBundle = DisplayQuotaStrBundleService.createBundle("chrome://displayquota/locale/displayquota.properties");
	} catch (ex) { dump("Erreur de chargement: " + ex + "\n"); }


        if(event != "OnItemAdded" && event != "FolderLoaded") return;

	var selectedURI = GetSelectedFolderURI();
	var folderResource = RDF.GetResource(selectedURI);
	if (folderResource) mMsgFolder = folderResource.QueryInterface(Components.interfaces.nsIMsgFolder);

        var msgFolder = GetMsgFolderFromUri(selectedURI, true);
	var serverType = msgFolder.server.type;


	if(serverType == "imap") {
		dump("In CheckQuota, event: Updating quota");
		var imapFolder = mMsgFolder.QueryInterface(Components.interfaces.nsIMsgImapMailFolder);
    		if (imapFolder) {
			imapFolder.fillInFolderProps(DisplayQuotaFolderPropsSink);
		}
	} else { 
		var quotaStatusBar = document.getElementById('DisplayQuota-statusbar');
		var quotaProgress = document.getElementById('DisplayQuota-progress-icon');
		var quotaLabelPC = document.getElementById('DisplayQuota-percent');

		var notimap = DisplayQuotaStrBundle.GetStringFromName("notimap");
      		quotaProgress.setAttribute("tooltiptext",notimap);
		quotaLabelPC.setAttribute("value","");
		quotaProgress.setAttribute("value",0);		
	}
}


var DisplayQuotaFolderListener = {
  OnItemAdded: function(parent, item, viewString) {},
  OnItemRemoved: function(parent, item, viewString) {},
  OnItemPropertyChanged: function(parent, item, viewString) {},
  OnItemIntPropertyChanged: function(item, property, oldValue, newValue) {},
  OnItemBoolPropertyChanged: function(item, property, oldValue, newValue) {},
  OnItemUnicharPropertyChanged: function(item, property, oldValue, newValue) {},
  OnItemPropertyFlagChanged: function(item, property, oldFlag, newFlag) {},
  OnItemEvent: checkQuota,
  OnDeleteOrMoveMessagesCompleted: function( aFolder) {}
}


function DisplayQuotaAddToSession()
{
	var mailSessionContractID = "@mozilla.org/messenger/services/session;1";
	try {
          var mailSession = Components.classes[mailSessionContractID].getService(Components.interfaces.nsIMsgMailSession);
          var nsIFolderListener = Components.interfaces.nsIFolderListener;
          var notifyFlags = nsIFolderListener.event;
          mailSession.AddFolderListener(DisplayQuotaFolderListener, notifyFlags);
        } catch (ex) { dump("Error adding to session\n"); }
}

function DisplayQuotaInit() {
	var pastDate = new Date("February 5, 2001 23:15:00");
	var DisplayQuotaPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);

	if (DisplayQuotaPrefs.getPrefType("extension.displayquota.lastwarn") == DisplayQuotaPrefs.PREF_STRING) {
		DisplayQuotaPrefs.setCharPref("extension.displayquota.lastwarn",pastDate);
	}
}


DisplayQuotaInit();
DisplayQuotaAddToSession();
